# Copyright (C) 2002-2009 NEC Corporation
# All Rights Reserved.
#
#  [See vndctl]

#
$ENV{LC_ALL}= 'POSIX';

##
#
sub linux_version{
    my($version)= 0;

    if(open(F, "/proc/version")){
        if(<F> =~ /^Linux version (\d+\.\d+\.\d+(-\S+)?)\s/){
            $version= $1;
        }
        close(F);
    }

    return $version;
}

#
sub pci_find_device{
    my($vendor, $device)= @_;

    my(@pci);
    if(open(PCI, "/proc/bus/pci/devices")){
        while(<PCI>){
            my(@id)= split(/\s+/, $_);
            if($id[1] eq "$vendor$device"){
                my($n)= hex($id[0]);
                $pci[$#pci+1]= [
                    sprintf("%02x", ($n >> 8)),
                    sprintf("%02x", (($n & 0xF8) >> 3)),
                    sprintf("%x", ($id[0] & 0x07))
                ];
            }
        }
        close(PCI);
    }

    return @pci;
}

#
sub modprobe{
    my($nam)= @_;
    system("/sbin/modprobe $nam 2>/dev/null");
}

#
sub pci_modprobe{
    my($nam)= @_;

    my(%pcimap)= &pci_get_pcimap();
    for $m (@{$pcimap{$nam}}){
        if(&pci_find_device(map {/0x....(....)/} @{$m}) > 0){
            &modprobe($nam);
            return 1;
        }
    }
}

#
sub pci_get_pcimap{
    my(%pcimap);

    my($version)= &linux_version();
    if($version && open(MAP, "/lib/modules/$version/modules.pcimap")){
        while(<MAP>){
            if(/(\S+)((\s+(0x[0-9a-z]+)){7})/){
                push(@{$pcimap{$1}}, [split(/\s+/, $2)]);
            }
        }
        close(MAP);
    }

    return %pcimap;
}

1;
