# Copyright (C) 2002-2009 NEC Corporation
# All Rights Reserved.
#
#  [See ftdisk]

#
$ENV{LC_ALL}= 'POSIX';

#
sub smuGetInput{
    my($prompt, $cancel, $reg)= @_;

    my($input);
    for(;;){
        printf("%s", ($prompt) ? $prompt : "Input? ");
        chomp($input= <STDIN>);
        if($input eq ''){
            last if($cancel);
        }
        else{
            last if($input =~ /$reg/);
            print STDERR "Invalid input: $input\n";
        }
    }

    return $input;
}

#
sub smuGetYesNo{
    my($prompt, $cancel)= @_;

    for(;;){
        my($input);
        printf("%s", ($prompt) ? $prompt : "[Y/N]? ");
        chomp($input= <STDIN>);
        if($input eq ''){
            return -1 if($cancel);
        }
        elsif($input =~ /^[yY]([eE][sS])?$/){
            return 1;
        }
        elsif($input =~ /^[nN]([oO])?$/){
            return 0;
        }
    }
}

#
sub smuGetNumber{
    my($prompt, $cancel, $min, $max)= @_;

    my($input);

    for(;;){
        printf("%s", ($prompt) ? $prompt : "[$min,$max]? ");
        chomp($input= <STDIN>);
        if($input eq ''){
            if($cancel){
                $input= ($min < 0) ? $min-1 : -1;
                last;
            }
        }
        else{
            last if(($input =~ /^-?\d+$/) and ($input >= $min)
                                          and ($input <= $max));
            print STDERR "Invalid number: $input\n";
        }
    }

    return $input;
}

#
sub smuGetKey{
    my($prompt, $cancel, $menu_ap, $prt_hp)= @_;

    my(@menu)= @{$menu_ap};
    my(%prt)= %{$prt_hp};

    my($input);
    foreach (@menu){
        if(/^(.*)=(\S+)$/){
            printf("%4s  %s\n", $2,
                   ($prt{$1}) ? $prt{$1}[0] : $1); 
        }
    }
    print "\n";
    for(;;){
        printf("%s", ($prompt) ? $prompt : "Choose: ");
        chomp($input= <STDIN>);
        if($input eq ''){
            return undef if($cancel);
        }
        else{
            foreach (@menu){
                if(/^(.*)=(\S+)$/){
                    return $1 if($input eq $2);
                }
            }
            print STDERR "Invalid choice: $input\n";
        }
    }
}

1;
